﻿using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
using Microsoft.IdentityModel.Tokens;

namespace FitConnect.SelfServicePortal;

public class KeyGenerator {
    private RSA _signingRsa;
    private RSA _encryptionRsa;

    public KeyGenerator() {
        _encryptionRsa = RSA.Create();
        _encryptionRsa = RSA.Create();
    }


    public JsonWebKey GenerateSigningKey() {
        // Create a new RSA key
        var rsa = RSA.Create();

        X509Certificate2 certificate = null!;
//         certificate.PublicKey = rsa.ExportRSAPublicKey();
// // Create a new self-signed certificate
//         var certificate = new X509Certificate2(
//             rsa,                             // RSA key
//             HashAlgorithmName.SHA256,        // Signature algorithm
//             "CN=MyCertificate",              // Subject name
//             "MyCertificate",                 // Friendly name
//             X509KeyUsageFlags.DataEncipherment, 
//             DateTime.UtcNow,                 // Not before
//             DateTime.UtcNow.AddYears(1)      // Not after
//         );

// Get the certificate chain as a byte array
        byte[] certificateChain = certificate.Export(X509ContentType.Cert);

// Convert the certificate chain to a base64 string
        string x5c = Convert.ToBase64String(certificateChain);

// Create a JWK from the RSA key and certificate chain
        var jwkKey = new JsonWebKey {
            Kty = "RSA",
            Alg = SecurityAlgorithms.RsaSha256Signature,
            Use = "sig",
            Kid = "rsa-key",
            X5c = { x5c }
        };

// Output the JWK key
        Console.WriteLine(jwkKey.ToString());
        return jwkKey;
    }

    public JsonWebKey GenerateEncryptionKey() {
        X509Certificate2 certificate = null!; // new X509Certificate2(_encryptionRsa);

// Get the certificate chain as a byte array
        byte[] certificateChain = certificate.Export(X509ContentType.Cert);

// Convert the certificate chain to a base64 string
        string x5c = Convert.ToBase64String(certificateChain);

// Create a JWK from the RSA key and certificate chain
        var jwkKey = new JsonWebKey {
            Kty = "RSA",
            Alg = SecurityAlgorithms.RsaSha256Signature,
            Use = "sig",
            Kid = "rsa-key",
            X5c = { x5c }
        };

        return jwkKey;
    }
}
